/* ------------------------------------------------------------ */
/*
HTTrack Website Copier, Offline Browser for Windows and Unix
Copyright (C) Xavier Roche, Yann Philippot

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


Important notes:

- We hereby ask people using this source NOT to use it in purpose of grabbing
emails addresses, or collecting any other private information on persons.
This would disgrace our work, and spoil the many hours we spent on it.


This project has been developed by Xavier Roche and Yann Philippot,
from the company Serianet at Caen, France (http://www.serianet.com)

Please visit our Website: http://www.httrack.com
*/


/* ------------------------------------------------------------ */
/* File: Some defines for httrack.c and others                  */
/* Author: Xavier Roche                                         */
/* ------------------------------------------------------------ */

// Fichier librairie .h
#ifndef HTS_DEFINES_DEFH
#define HTS_DEFINES_DEFH

// demande d'interaction avec le shell
#if HTS_ANALYSTE!=2
#define HT_PRINT(A) printf("%s",A);
#define HT_REQUEST_START /*printf("\n");*/
#define HT_REQUEST_END   /*printf("\n");*/
#define HTT_REQUEST_START /*if (httrack.shell) printf("\n");*/
#define HTT_REQUEST_END   /*if (httrack.shell) printf("\n");*/
#define HTS_REQUEST_START if (opt->shell) { HT_REQUEST_START }
#define HTS_REQUEST_END   if (opt->shell) { HT_REQUEST_END }
#define HTS_PANIC_PRINTF(S) printf("%s\n",S);
#else
extern char HTbuff[2048];
#define HT_PRINT(A) strcat(HTbuff,A);
#define HT_REQUEST_START HTbuff[0]='\0';
#define HT_REQUEST_END 
#define HTT_REQUEST_START HTbuff[0]='\0';
#define HTT_REQUEST_END 
#define HTS_REQUEST_START HTbuff[0]='\0';
#define HTS_REQUEST_END 
#define HTS_PANIC_PRINTF(S) strcpy(_hts_errmsg,S);
void  hts_htmlcheck_init();
void  hts_htmlcheck_uninit();
int   hts_htmlcheck_start();
int   hts_htmlcheck_end();
int   hts_htmlcheck(char* html,int len,char* url_adresse,char* url_fichier);
char* hts_htmlcheck_query(char* question);
char* hts_htmlcheck_query2(char* question);
char* hts_htmlcheck_query3(char* question);
int   hts_htmlcheck_loop(lien_back* back,int back_max,int back_index,int lien_tot,int lien_ntot,LLint stat_bytes,LLint stat_bytes_recv,int stat_time,int stat_nsocket,LLint stat_written, int stat_updated, int stat_errors);
int   hts_htmlcheck_check(char* adr,char* fil,int status);
#endif

#endif

